/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2024 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "stdio.h"
#include "st7567s.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
I2C_HandleTypeDef hi2c1;

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_I2C1_Init(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_I2C1_Init();
  /* USER CODE BEGIN 2 */

  uint8_t buff[20];

  LCD_Init();
  LCD_Clear();

  // LCD Demo
  // Text
  sprintf((char *) buff, " LCD_print()");
  LCD_SetTextPos(0, 0);
  LCD_print(buff, 1);
  LCD_IvertLine(0);

  sprintf((char *) buff, "Font size: 1");
  LCD_SetTextPos(0, 1);
  LCD_print(buff, 1);


  sprintf((char *) buff, "Size: 2");
  LCD_SetTextPos(0, 2);
  LCD_print(buff, 2);


  sprintf((char *) buff, "-35.6");
  LCD_SetTextPos(0, 4);
  LCD_print(buff, 4);

  LCD_Update();
  HAL_Delay(2000);

  // Pixel
  LCD_Clear();
  sprintf((char *) buff, " LCD_DrawPixel()");
  LCD_SetTextPos(0, 0);
  LCD_print(buff, 1);
  LCD_IvertLine(0);

  for (uint8_t x=0; x< 128; x+=2) {
	  for (uint8_t y=10; y< 64; y+=2) {
		  LCD_DrawPixel(x, y, 1);
	  }
  }

  LCD_Update();
  HAL_Delay(2000);

  // Line
  LCD_Clear();
  sprintf((char *) buff, " LCD_DrawLine()");
  LCD_SetTextPos(0, 0);
  LCD_print(buff, 1);
  LCD_IvertLine(0);

  LCD_DrawLine(0, 10, 127, 63, 1);
  LCD_DrawLine(127, 10, 0, 63, 1);
  LCD_DrawLine(0, 10, 127, 10, 1);
  LCD_DrawLine(0, 63, 127, 63, 1);
  LCD_DrawLine(0, 0, 0, 63, 1);
  LCD_DrawLine(127, 0, 127, 63, 1);

  LCD_Update();
  HAL_Delay(2000);

  // LCD_DrawRect
  LCD_Clear();
  sprintf((char *) buff, " LCD_DrawRect()");
  LCD_SetTextPos(0, 0);
  LCD_print(buff, 1);
  LCD_IvertLine(0);

  LCD_DrawRect(10, 10, 20, 20, 1);
  LCD_DrawRect(0, 30, 60, 50, 1);
  LCD_DrawRect(40, 20, 60, 60, 1);
  LCD_DrawRect(80, 25, 120, 60, 1);
  LCD_DrawRect(85, 30, 115, 55, 1);

  LCD_Update();
  HAL_Delay(2000);

  // LCD_DrawCircle
  LCD_Clear();
  sprintf((char *) buff, " LCD_DrawCircle()");
  LCD_SetTextPos(0, 0);
  LCD_print(buff, 1);
  LCD_IvertLine(0);

  LCD_DrawCircle(50, 30, 10, 1);
  LCD_DrawCircle(65, 30, 10, 1);
  LCD_DrawCircle(80, 30, 10, 1);

  LCD_DrawCircle(57, 45, 10, 1);
  LCD_DrawCircle(72, 45, 10, 1);

  LCD_DrawCircle(64, 32, 40, 1);

  LCD_Update();
  HAL_Delay(2000);

  // LCD_Image
  unsigned char Picture[8][128] =
  	{
  	 {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xE0,0xE0,0xE0,0xE0,0xE0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
  	 {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xC0,0xF8,0xFF,0xFF,0xFF,0xFF,0x1F,0x3,0x1F,0xFF,0xFF,0xFF,0xFF,0xF8,0xC0,0x0,0x0,0x0,0x4,0x3C,0xFC,0xFC,0xFC,0xF8,0x80,0x0,0x80,0xF8,0xFC,0xFC,0xFC,0x3C,0x4,0x0,0x0,0xFC,0xFC,0xFC,0xFC,0xFC,0x0,0x0,0x0,0xF0,0xF8,0xF8,0xFC,0xFC,0x9C,0x9C,0x9C,0x9C,0xBC,0x3C,0x38,0x30,0x20,0x0,0x0,0x0,0xFF,0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x0,0x30,0x38,0x78,0x7C,0x7C,0x3C,0x1C,0x1C,0x9C,0xFC,0xFC,0xF8,0xF8,0xE0,0x0,0x0,0x0,0x0,0xFF,0xFF,0xFF,0xFF,0xFF,0x38,0x1C,0x1C,0x3C,0xFC,0xFC,0xF8,0xF0,0xC0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
  	 {0x0,0x0,0x0,0x0,0x80,0xF0,0xFE,0xFF,0xFF,0xFF,0x7F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x7F,0xFF,0xFF,0xFF,0xFE,0xF0,0x80,0x0,0x0,0x1,0x7,0x3F,0xFF,0xFF,0xF8,0xFF,0xFF,0x3F,0x7,0x0,0x0,0x0,0x0,0x0,0xFF,0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x10,0x70,0x79,0xFB,0xFB,0xF3,0xE3,0xE7,0xE7,0xE7,0xFF,0xFF,0x7F,0x3E,0x1C,0x0,0x0,0x0,0xFF,0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x0,0x3C,0x7E,0xFE,0xFF,0xFF,0xE7,0xE7,0x63,0x73,0x7F,0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x0,0x0,0xFF,0xFF,0xFF,0xFF,0xFF,0x70,0xE0,0xE0,0xF0,0xFF,0xFF,0x7F,0x3F,0xF,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x80,0xC0,0xE0,0xF0,0x70,0x38,0x38,0x10,0x0,0x0},
  	 {0x0,0x0,0x0,0x0,0x0,0x80,0x80,0x0,0x0,0x0,0x0,0x80,0x80,0x80,0x0,0x0,0x80,0x30,0x20,0xB0,0x0,0x80,0x80,0x80,0x80,0x80,0x0,0x0,0x0,0x0,0x0,0x80,0x80,0x80,0x0,0x0,0x80,0x80,0x80,0x80,0x0,0x0,0x0,0x80,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0xE0,0xF8,0xF8,0xFC,0xFC,0xFE,0xFF,0x3F,0x1F,0xF,0x3,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
  	 {0x0,0x0,0x0,0x0,0x7,0x8,0x8,0x5,0x0,0x0,0xC,0xA,0xA,0xF,0x0,0x0,0xF,0x6,0x1,0xF,0x0,0x0,0x0,0xF,0x0,0x0,0x0,0x0,0x0,0x0,0x1C,0xB,0x8,0xF,0x18,0x8,0x7,0x0,0x0,0xF,0x0,0x0,0xD,0x2,0xF,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0xC0,0xE0,0xE0,0xF0,0x78,0x3C,0x1E,0xF,0x7,0x7,0x3,0x1,0x1,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
  	 {0x0,0x0,0x0,0x0,0x3E,0x2,0x2,0x3E,0x0,0x0,0x30,0x2A,0x2A,0x3E,0x0,0x20,0x1E,0x2,0x2,0x3E,0x0,0x0,0x3E,0x1C,0x22,0x0,0x0,0x3E,0x18,0x4,0x3E,0x0,0x22,0x14,0x8,0x14,0x22,0x0,0x0,0x0,0x0,0x3E,0x2,0x2,0x3E,0x0,0x0,0x30,0x2A,0x2A,0x3E,0x0,0x0,0x34,0xA,0x3E,0x0,0x20,0x1E,0x2,0x2,0x3E,0x0,0x0,0x3E,0x28,0x28,0x10,0x0,0x0,0x3E,0x8,0x8,0x3E,0x0,0x0,0x3E,0x18,0x4,0x3E,0x0,0x0,0x3E,0x1C,0x22,0x0,0x0,0x3E,0x0,0x0,0x3E,0x2A,0x14,0x0,0x0,0x0,0x20,0x10,0x18,0xE,0x7,0x7,0x3,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
  	 {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x0,0x80,0x0,0x0,0x0,0x0,0x0,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0},
  	 {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1E,0x20,0x1C,0x2,0x1C,0x20,0x1E,0x1E,0x20,0x1C,0x2,0x1C,0x20,0x1E,0x1E,0x20,0x1C,0x2,0x1C,0x20,0x1E,0x0,0x20,0x0,0x0,0x30,0x2A,0x2A,0x3E,0x0,0x2,0x1C,0x20,0x1C,0x2,0x0,0x3E,0x0,0x24,0x2A,0x2A,0x12,0x0,0x3F,0x0,0x0,0x30,0x2A,0x2A,0x3E,0x0,0x0,0x3F,0x22,0x22,0x1C,0x0,0x0,0x20,0x0,0x0,0x1C,0x22,0x22,0x14,0x0,0x1C,0x22,0x22,0x1C,0x0,0x0,0x3E,0x2,0x2,0x3E,0x2,0x2,0x3C,0x0,0x30,0xE,0x1,0x0,0x3F,0x22,0x22,0x1C,0x0,0x0,0x3F,0x0,0x0,0x1C,0x22,0x22,0x1C,0x0,0x0,0x5C,0xA2,0xA2,0x7E,0x0,0x30,0xE,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0}
  	};

  LCD_Image(*Picture);

  LCD_Update();


  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief I2C1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_I2C1_Init(void)
{

  /* USER CODE BEGIN I2C1_Init 0 */

  /* USER CODE END I2C1_Init 0 */

  /* USER CODE BEGIN I2C1_Init 1 */

  /* USER CODE END I2C1_Init 1 */
  hi2c1.Instance = I2C1;
  hi2c1.Init.ClockSpeed = 400000;
  hi2c1.Init.DutyCycle = I2C_DUTYCYCLE_2;
  hi2c1.Init.OwnAddress1 = 0;
  hi2c1.Init.AddressingMode = I2C_ADDRESSINGMODE_7BIT;
  hi2c1.Init.DualAddressMode = I2C_DUALADDRESS_DISABLE;
  hi2c1.Init.OwnAddress2 = 0;
  hi2c1.Init.GeneralCallMode = I2C_GENERALCALL_DISABLE;
  hi2c1.Init.NoStretchMode = I2C_NOSTRETCH_DISABLE;
  if (HAL_I2C_Init(&hi2c1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN I2C1_Init 2 */

  /* USER CODE END I2C1_Init 2 */

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOD_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
